
#include "Snake.h"


namespace snk {
	Snake::Snake(int gridX, int gridY, int radius, int length, std::string direction) {
		for (int i = 0; i < length; i++) {
			createSegment(gridX, gridY, radius, direction);
		}
	}

	Snake::~Snake(void) {
	}

	void Snake::createSegment(int gridX, int gridY, int radius, std::string direction) {
		segments.push_back(Segment(gridX, gridY, radius, direction));
	}

	void Snake::killSegmentRange(int pos) {
		segments.erase(segments.begin() + pos, segments.end());
	}

	void Snake::gridMove(void) {
		int oldGridX, oldGridY;
		int newGridX, newGridY;
		std::string oldDirection, newDirection;

		oldGridX = segments[0].getGridX();
		oldGridY = segments[0].getGridY();
		oldDirection = segments[0].getDirection();

		segments[0].gridMove(segments[0].getDirection());

		for (int i = 1; i < segments.size(); i++) {
			newGridX = oldGridX;
			newGridY = oldGridY;
			newDirection = oldDirection;

			oldGridX = segments[i].getGridX();
			oldGridY = segments[i].getGridY();
			oldDirection = segments[0].getDirection();

			segments[i].setGrid(newGridX, newGridY);
			segments[i].setDirection(newDirection);
		}
	}

	void Snake::draw(sf::RenderWindow & rW) {
		for (int i = 0; i < segments.size(); i++) {
			int x = segments[i].getGridX();
			int y = segments[i].getGridY();
			int r = segments[i].getRadius();

			rW.Draw(sf::Shape::Circle(x * (r * 2) + r, y * (r * 2) + r, r, sf::Color(255, 255, 0, 255), r * 0.1, sf::Color(0, 0, 0, 255)));
		}
	}

	void Snake::input(sf::Event Event) {
		if (Event.Key.Code == sf::Key::Left) {
			segments[0].setDirection("left");
		}

		if (Event.Key.Code == sf::Key::Right) {
			segments[0].setDirection("right");
		}

		if (Event.Key.Code == sf::Key::Up) {
			segments[0].setDirection("up");
		}

		if (Event.Key.Code == sf::Key::Down) {
			segments[0].setDirection("down");
		}
	}

	void Snake::update(void) {
		gridMove();
	}
}